#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\radiobut.h>
#include <owl\gdiobjec.h>
#include "pr49_1.rc"

//  .
struct
{
  BOOL buttons [12];
} transBuf;

// .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
  protected:
	 void CmCursor();
  private:
	 void ChangeCursor();

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	EV_COMMAND (CM_CURSOR, CmCursor),
END_RESPONSE_TABLE;

//    Select Cursor.
class TDlg : public TDialog
{
  public:
	 TDlg(TWindow *parent, TResId resId);
};

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow (parent, title)
{
  //     .
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 400;
  Attr.H = 300;
  //    .
  AssignMenu(MENU_1);
  //   .
  memset (&transBuf,0,sizeof(transBuf));
  transBuf.buttons[0] = TRUE;
}

// TWndw::CmCursor()
//      CM_CURSOR,
//  ,  
//   Select Cursor   Cursor.
void TWndw::CmCursor()
{
  //    Select Cursor.
  TDialog *dialog = new TDlg (this, CURSORDLG);
  //  .
  int result = dialog->Execute();
  //      ...
  if (result == IDOK)
	 //    .
	 ChangeCursor();
}

// TWndw::ChangeCutsor()
//      
//    -  
//   SelectCursor,   
//   .
void TWndw::ChangeCursor()
{
  int selection;
  const char *cursor;
  HINSTANCE  instance;
  HCURSOR  hCursor;
  //   -.
  for (int x = 0; x < 12; ++x)
	 if (transBuf.buttons[x]) selection = x;
  //   ,  .
  switch (selection)
  {
	 case  0 :  cursor = IDC_ARROW;break;
	 case  1 :  cursor = IDC_CROSS;break;
	 case  2 :  cursor = IDC_IBEAM;break;
	 case  3 :  cursor = IDC_ICON;break;
	 case  4 :  cursor = IDC_SIZE;break;
	 case  5 :  cursor = IDC_SIZENESW;break;
	 case  6 :  cursor = IDC_SIZENS;break;
	 case  7 :  cursor = IDC_SIZENWSE; break;
	 case  8 :  cursor = IDC_SIZEWE; break;
	 case  9 :  cursor = IDC_UPARROW; break;
	 case 10 :  cursor = IDC_WAIT; break;
	 case 11 :  cursor = "IDC_TARGET"; break;
  }
  //      ...
  if (selection == 11)
	 //      .
	 instance = *GetApplication() ;
  else
	 //   instance  NULL, 
	 //     Windows.
	 instance = NULL;
  //    .
  hCursor = LoadCursor (instance, cursor);
  //     
  //    .
  SetClassWord (GCW_HCURSOR, (WORD) hCursor);
}
//**************************************
//   TDlg.
//**************************************
// TDlg::TDlg()
//     SelectCursor.
TDlg::TDlg(TWindow *parent, TResId resId): TDialog (parent, resId)
{
  //    OWL  
  //    , 
  //      .
  new TRadioButton(this, ID_ARROWBUT, 0);
  new TRadioButton(this, ID_CROSSBUT, 0);
  new TRadioButton(this, ID_IBEAMBUT, 0);
  new TRadioButton(this, ID_ICONBUT, 0);
  new TRadioButton(this, ID_SIZEBUT, 0);
  new TRadioButton(this, ID_NESWBUT, 0);
  new TRadioButton(this, ID_NSBUT, 0);
  new TRadioButton(this, ID_NWSEBUT, 0);
  new TRadioButton(this, ID_WEBUT, 0);
  new TRadioButton(this, ID_UPBUT, 0);
  new TRadioButton(this, ID_WAITBUT, 0) ;
  new TRadioButton(this, ID_TARGETBUT, 0);
  //    .
  TransferBuffer = &transBuf;
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0," ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
